
// program to display a frame with "hello world"

import java.awt.*;
import java.awt.event.*;

// "original" AWT (abstract window tookit)
// Swing (new and improved java UI).
// in class, we'll mostly use AWT (simpler).
public class MyDraw extends Frame {
    
    public pList lines = new pList();
    public int mousex,mousey;
    
    public MyDraw(){
        super();
        // capture the Window close button event
        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e) {
                // kill program when someone
                // closes this window.
                System.exit(0);
            }
        });
        addMouseListener(new MouseAdapter(){
            public void mousePressed(MouseEvent e) {
                mousex = e.getX();
                mousey = e.getY();
            }
        });
        addMouseMotionListener(new MouseAdapter(){
            public void mouseDragged(MouseEvent e){
                lines.push(new int[]{
                    mousex,mousey,
                    e.getX(),e.getY()
                });
                mousex = e.getX();
                mousey = e.getY();
                repaint();
            }
        });
        setSize(640,480);
    }
    public void paint(Graphics g){
        g.setColor(Color.black);
        for(int i=0;i<lines.size();i++){
            int[] a = (int[])lines.get(i);
            g.drawLine(a[0],a[1],a[2],a[3]);
        }
        //g.drawString("Hello World",bounds().width/2,bounds().height/2);
    }
    public static void main(String[] args){
        MyDraw f = new MyDraw();
        f.show();
    }
}



