
// program to display a frame with "hello world"

import java.awt.*;
import java.awt.event.*;

// "original" AWT (abstract window tookit)
// Swing (new and improved java UI).
// in class, we'll mostly use AWT (simpler).
public class MyDrawRect extends Frame {
    
    public pList obj = new pList();
    public Rectangle selected = null;
    public String mode = "DRAW";
    public int mousex,mousey;
    
    public MyDrawRect(){
        super();
        // capture the Window close button event
        addWindowListener(new WindowAdapter(){
            public void windowClosing(WindowEvent e) {
                // kill program when someone
                // closes this window.
                System.exit(0);
            }
        });
        addMouseListener(new MouseAdapter(){
            public void mousePressed(MouseEvent e) {
                if(mode.equals("DRAW")){
                    // create new rectangle in draw mode
                    selected = new Rectangle(e.getX(),e.getY(),0,0);
                }else if(mode.equals("SELECT")){
                    mousex = e.getX();
                    mousey = e.getY();
                    // find rectangle that contains our
                    // mouse location.
                    for(int i=0;i<obj.size();i++){
                        Rectangle r = (Rectangle)obj.get(i);                 if(r.contains(e.getX(),e.getY())){
                            selected = r;
                            break;
                        }
                    }             
                }
            }
            public void mouseReleased(MouseEvent e) {
                if(selected != null && mode.equals("DRAW")){
                    obj.push(selected);
                }
                selected = null;
                repaint();
            }
        });
        addMouseMotionListener(new MouseAdapter(){
            public void mouseDragged(MouseEvent e){
                if(selected != null){
                    if(mode.equals("DRAW")){ 
                        selected.width = (int)Math.max(0,e.getX() - selected.x);
                        selected.height = (int)Math.max(0,e.getY() - selected.y);
                    } else if(mode.equals("SELECT")){
                        selected.x += e.getX() - mousex;
                        selected.y += e.getY() - mousey;
                        mousex = e.getX();
                        mousey = e.getY();
                    }
                }
                repaint();
            }
        });
        Panel p = new Panel();
        Button b;
        b = new Button("DRAW");
        b.addActionListener(
            new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    mode = "DRAW";    
                }
            }
        );
        p.add(b);
        b = new Button("SELECT");
        b.addActionListener(
            new ActionListener(){
                public void actionPerformed(ActionEvent e){
                    mode = "SELECT";
                }
            }
        );
        p.add(b);        
        add(p,BorderLayout.NORTH);
        setSize(640,480);
    }
    public void paint(Graphics g){
        g.setColor(Color.black);
        for(int i=0;i<obj.size();i++){
            Rectangle r = (Rectangle)obj.get(i);
            g.drawRect(r.x,r.y,r.width,r.height);
        }
        if(selected != null){
            g.setColor(Color.red);
            g.drawRect(selected.x,selected.y,
              selected.width,selected.height);            
        }
    }
    public static void main(String[] args){
        MyDrawRect f = new MyDrawRect();
        f.show();
    }
}



